/*********************************************
  PowerButton Launcher (as good old PowerButtonHack)
  but for PalmOS5
  (C) 2004 Hynek Sladky; sladky@mujmail.cz
*********************************************/
#include <PalmOS.h>
#include "PowerButton.h"

#define creator 'PBtn'

/* ToDo:

- tlacitko OK je zbytecne!!!

x nenabizet sebe sama
x nenabizet aplikace s atributem Hidden
x zkusit, jak se bude chovat, kdyz aplikaci smazu
  - no - chova se to divoce: 'Bus Error'
  - takze je potreba kontrolovat, zda je stale card a dbid platne... ale JAK?
x LstSetTopItem...
x autoaktivace po resetu
x HiRes ikony (256colors)

- pokud je stisknuto HardButton (krome Power), tak nic nedelam!
- pokud uz je vybrana aplikace spustena, tak nic nedelam
*/

// preferences structure
typedef struct {
  Boolean enabled;
  UInt32 seconds;
  UInt16 card;
  char name[33];
} prefstruct;

void *GetControlPtr (FormPtr frm, UInt16 id) {
  return FrmGetObjectPtr (frm, FrmGetObjectIndex (frm ,id));
}

void LoadPrefs (prefstruct *prefptr) {
UInt16  prefsize;
  prefsize=0;
  PrefGetAppPreferences (creator, 0, NULL, &prefsize, true);
  if (prefsize>sizeof (prefstruct))
    prefsize=sizeof (prefstruct);
  PrefGetAppPreferences (creator, 0, prefptr, &prefsize, true);
}

static Boolean SetupFormHandler (EventPtr event) {

static UInt16   card;
static char**   ListMem;
static char     hour[3], min[3];
static UInt8    hours, minutes;

Boolean         handled;
FormPtr         form;
prefstruct      prefs;
Err             error;
DmSearchStateType Srch;
LocalID         db_id, mydbid;
UInt16          mycard;
UInt16          ListLen;
UInt16          ListPos, ListSel;
ListPtr         list;
UInt32          retval;
UInt16          attributes;

  handled=false;
  form=FrmGetActiveForm ();
  switch (event->eType) {
  case frmOpenEvent:
    // nactu preference
    LoadPrefs (&prefs);
    // zobrazim nastavene hodnoty
    CtlSetValue (GetControlPtr (form, PBenable), prefs.enabled);
    // nactu seznam aplikaci a vlozim je do listu
    // jeden nazev je (32+1)B
    error=DmGetNextDatabaseByTypeCreator (true, &Srch, 'appl', 0, false, &card, &db_id);
    ListLen=0;
    SysCurAppDatabase (&mycard, &mydbid);
    while (!error && db_id) {
      DmDatabaseInfo (card, db_id, NULL, &attributes, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      if (!(attributes&dmHdrAttrHidden) && (card!=mycard || db_id!=mydbid))
	ListLen++;
      error=DmGetNextDatabaseByTypeCreator (false, &Srch, 'appl', 0, false, &card, &db_id);
    }
    // alokuju pamet pro ukazatele
    ListMem=MemPtrNew (ListLen*sizeof(char*));
    // alokuju pamet pro nazvy
    ListMem[0]=MemPtrNew (ListLen*33);
    // nastavim ukazatele
    for (ListPos=1; ListPos<ListLen; ListPos++)
      ListMem[ListPos]=&(ListMem[ListPos-1][33]);
    error=DmGetNextDatabaseByTypeCreator (true, &Srch, 'appl', 0, false, &card, &db_id);
    ListPos=ListSel=0;
    while (!error && db_id) {
      DmDatabaseInfo (card, db_id, NULL, &attributes, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      if (!(attributes&dmHdrAttrHidden) && (card!=mycard || db_id!=mydbid)) {
	DmDatabaseInfo (card, db_id, ListMem[ListPos], NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (!StrCompare (prefs.name, ListMem[ListPos]))
	  ListSel=ListPos;
	ListPos++;
      }
      error=DmGetNextDatabaseByTypeCreator (false, &Srch, 'appl', 0, false, &card, &db_id);
    }
    // nastavim list
    LstSetListChoices (list=GetControlPtr (form, PBappllist), ListMem, ListLen);
    LstSetSelection (list, ListSel);
    LstSetTopItem (list, ListSel);
    CtlSetLabel (GetControlPtr (form, PBappltrig), ListMem[ListSel]);
    // zobrazim cas
    hours=prefs.seconds/3600;
    minutes=(prefs.seconds/60)%60;
    if (hours>99) hours=99;
    //if (minutes>59) minutes=59;
    StrPrintF (hour, "%02d", hours);
    StrPrintF (min, "%02d", minutes);
    FldSetTextPtr (GetControlPtr (form, PBhour), hour);
    FldSetTextPtr (GetControlPtr (form, PBmin), min);
    // vykreslim formular
    FrmDrawForm (form);
    handled=true;
    break;
  case frmCloseEvent:
    // vezmu zvolene hodnoty
    prefs.enabled=CtlGetValue (GetControlPtr (form, PBenable));
    ListSel=LstGetSelection (GetControlPtr (form, PBappllist));
    if (ListSel==noListSelection) {
      *prefs.name=0;
      prefs.enabled=false;
    } else {
      prefs.card=card;
      StrCopy (prefs.name, ListMem[ListSel]);
    }
    prefs.seconds=hours*3600L+minutes*60L;
    if (!prefs.seconds) prefs.seconds=30;
    // ulozim je do preferenci
    PrefSetAppPreferences (creator, 0, 0, &prefs, sizeof (prefstruct), true);
    // uvolnim pamet
    MemPtrFree (*ListMem);
    MemPtrFree (ListMem);
    break;
  case ctlSelectEvent:
    switch (event->data.ctlSelect.controlID) {
    case PB_OK:
      event->eType=appStopEvent;
      EvtAddEventToQueue (event);
      break;
/*
    case PBtry:
      LoadPrefs (&prefs);
      //SysAppLaunch (prefs.card, prefs.dbid, 0, sysAppLaunchCmdNormalLaunch, NULL, NULL);
      SysUIAppSwitch (prefs.card, prefs.dbid, sysAppLaunchCmdNormalLaunch, NULL);
      break;
*/
    }
    break;
  case ctlRepeatEvent:
    switch (event->data.ctlSelect.controlID) {
    case PBhrup:
      if (hours<99)
	hours++;
      hours++;
    case PBhrdn:
      if (hours)
	hours--;
      StrPrintF (hour, "%02d", hours);
      FldDrawField (GetControlPtr (form, PBhour));
      break;
    case PBminup:
      if (minutes<59)
	minutes++;
      minutes++;
    case PBmindn:
      if (minutes)
	minutes--;
      StrPrintF (min, "%02d", minutes);
      FldDrawField (GetControlPtr (form, PBmin));
      break;
    }
    break;
  }

  return handled;
}

/******
#define sysNotifyAppLaunchingEvent          'hapl'              // Sent before an app is launched (normalLaunch only)
							// Note: future OS releases might not send this notification.
#define sysNotifyAppQuittingEvent           'hapq'      // Sent right after an app has quit (normalLaunch only)
							// Note: future OS releases might not send this notification.
// for sysNotifyAppLaunchingEvent and sysNotifyAppQuittingEvent
typedef struct SysNotifyAppLaunchOrQuitTag {
	UInt32    version;   // this is version 0
	UInt32    dbID;      // the application being started or quitting (note: type unsafeness is intentional)
	UInt16    cardNo;    // the application being started or quitting
} SysNotifyAppLaunchOrQuitType;
******/

Err MyNotifyProc (SysNotifyParamType *params) {
prefstruct      prefs;
UInt32          lastoff;
LocalID         dbid;

  if (params->notifyType==sysNotifySleepNotifyEvent) {
    FtrSet (creator, 0, TimGetSeconds ());
    return 0;
  }
  if (params->notifyType==sysNotifyEarlyWakeupEvent) {
    FtrSet (creator, 1, KeyCurrentState ());
    return 0;
  }
  if (params->notifyType==sysNotifyAppLaunchingEvent) {
    FtrSet (creator, 2, ((SysNotifyAppLaunchOrQuitType*)params->notifyDetailsP)->dbID);
  }
  if (params->notifyType==sysNotifyLateWakeupEvent) {
    // musim zjistit, zda neni stisknute tlacitko HardButton 1-4
    // normalne je ve fronte jen vchrLateWakeup
    // pri stisku HardButton je ve fronte nejdriv vchrHardButtonx, pak teprve vchrLateWakeup
    // pri stisku PageUp (zobrazeni hodin ve stavu OFF) se posle vchrPageUpWhenOff, pak teprve vchrLateWapeup
    // tj. mel bych asi zjistit, kolik udalosti je ve fronte Key...

//    FtrSet (creator, 1, EvtKeyQueueSize ());
//    if (EvtKeyQueueSize ()>???)
//      return 0;

    // podivam se, jestli nebyla stisknuta HW tlacitka
    if (!FtrGet (creator, 1, &lastoff)) {
//      if (lastoff & (keyBitHard1 | keyBitHard2 | keyBitHard3 | keyBitHard4))
      if (lastoff & (keyBitHard1 | keyBitHard2 | keyBitHard3)) // for treo 650
	return 0;
    }
    // nactu preference
    LoadPrefs (&prefs);
    // najdu cardno a dbid od pozadovane aplikace
    dbid=DmFindDatabase (prefs.card, prefs.name);
    // nejdriv zkontroluju, ze aplikace jeste existuje
    if (!dbid)
      return 0;
    // podivam se, jestli dana aplikace neni spustena
    if (!FtrGet (creator, 2, &lastoff)) {
      if (lastoff==dbid)
	return 0;
    }
    // nactu cas posledniho vypnuti
    if (FtrGet (creator, 0, &lastoff))
      lastoff=TimGetSeconds ();
    // podivam se, jestli od posledniho vypnuti uplynulo dost casu
    if ((TimGetSeconds ()-lastoff)>prefs.seconds && *prefs.name) {
      // a ted ji muzu spustit
      if (dbid) // && dbid!=dbidnow && prefs.card!=cardnow)
	//SysAppLaunch (prefs.card, prefs.dbid, 0, sysAppLaunchCmdNormalLaunch, NULL, &lastoff);
	SysUIAppSwitch (prefs.card, dbid, sysAppLaunchCmdNormalLaunch, NULL);
    }
  }
  return 0;
}

// SysAppLaunch (card, dbid, launchflags, cmd, cmdPBP, &result)

UInt32 PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
EventType       event;
FormPtr         form;
UInt16          err;
prefstruct      prefs;
UInt32          ftrval;
UInt16          mycard;
LocalID         mydbid;

  if (cmd==sysAppLaunchCmdNotify)
    return MyNotifyProc ((SysNotifyParamType*)cmdPBP);

  if (cmd==sysAppLaunchCmdNormalLaunch) {
    // event loop
    FrmGotoForm (SetupForm);
    do {
      EvtGetEvent (&event, evtWaitForever);
      if (SysHandleEvent (&event)) continue;
      if (MenuHandleEvent (NULL, &event, &err)) continue;
      if (event.eType==frmLoadEvent) {
	FrmSetActiveForm (form = FrmInitForm (event.data.frmLoad.formID));
	switch (event.data.frmLoad.formID) {
	case SetupForm:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) SetupFormHandler);
	  break;
	}
      }
      FrmDispatchEvent (&event);
    } while (event.eType!=appStopEvent);
    FrmCloseAllForms ();
  }
  if (cmd==sysAppLaunchCmdNormalLaunch || cmd==sysAppLaunchCmdSystemReset) {
    // nactu preference
    LoadPrefs (&prefs);
    // nastavim notifikaci
    SysCurAppDatabase (&mycard, &mydbid);
    if (prefs.enabled) {
      // podivam se, jestli existuje feature -> t.j. jestli jsem registrovany
      if (FtrGet (creator, 0, &ftrval)) {
	// feature neexistuje, tedy se muzu zaregistrovat
/***
	SysNotifyRegister (mycard, mydbid, sysNotifyEarlyWakeupEvent, &MyNotifyProc, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifyLateWakeupEvent, &MyNotifyProc, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifySleepNotifyEvent, &MyNotifyProc, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifyAppLaunchingEvent, &MyNotifyProc, sysNotifyNormalPriority, NULL);
	//SysNotifyRegister (mycard, mydbid, sysNotifyAppQuittingEvent, &MyNotifyProc, sysNotifyNormalPriority, NULL);
***/
	SysNotifyRegister (mycard, mydbid, sysNotifyEarlyWakeupEvent, NULL, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifyLateWakeupEvent, NULL, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifySleepNotifyEvent, NULL, sysNotifyNormalPriority, NULL);
	SysNotifyRegister (mycard, mydbid, sysNotifyAppLaunchingEvent, NULL, sysNotifyNormalPriority, NULL);
	//SysNotifyRegister (mycard, mydbid, sysNotifyAppQuittingEvent, NULL, sysNotifyNormalPriority, NULL);

	FtrSet (creator, 0, TimGetSeconds ());
      }
    } else
    if (cmd!=sysAppLaunchCmdSystemReset) {
      SysNotifyUnregister (mycard, mydbid, sysNotifyEarlyWakeupEvent, sysNotifyNormalPriority);
      SysNotifyUnregister (mycard, mydbid, sysNotifyLateWakeupEvent, sysNotifyNormalPriority);
      SysNotifyUnregister (mycard, mydbid, sysNotifySleepNotifyEvent, sysNotifyNormalPriority);
      SysNotifyUnregister (mycard, mydbid, sysNotifyAppLaunchingEvent, sysNotifyNormalPriority);
      //SysNotifyUnregister (mycard, mydbid, sysNotifyAppQuittingEvent, sysNotifyNormalPriority);
      FtrUnregister (creator, 0);
      FtrUnregister (creator, 1);
    }
  }

  return 0;
}
